package com.kdanmobile.kdanloginregisterui

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.view.inputmethod.InputMethodManager
import androidx.appcompat.app.AlertDialog
import com.kdanmobile.kdanloginregisterui.widget.EmailLoginFormView
import kotlinx.android.synthetic.main.activity_login_b.view.*

class LoginBView @JvmOverloads constructor(
    context: Context,
    attrs: AttributeSet? = null,
    defStyleAttr: Int = 0
) : BaseLoginView(context, attrs, defStyleAttr) {

    private val view = LayoutInflater.from(context).inflate(R.layout.dialog_email_login, null)
    private val formView = view.findViewById<EmailLoginFormView>(R.id.formView_emailLoginDialog)

    override var email: String
        get() {
            return formView.email
        }
        set(value) {
            formView.email = value
        }
    override var pwd: String
        get() {
            return formView.pwd
        }
        set(value) {
            formView.pwd = value
        }
    override var isRemember: Boolean
        get() {
            return formView.isRemember
        }
        set(value) {
            formView.isRemember = value
        }

    init {
        View.inflate(context, R.layout.activity_login_b, this)
        setupTosAndPpTextView(tv_loginB_tosAndPp)
        setupSwitchTextView(tv_loginB_switchToRegister)
        setupEmailLoginBtn()
        view_loginB_fbLogin.setOnClickListener { onClickFbLogin.run() }
        view_loginB_googleLogin.setOnClickListener { onClickGoogleLogin.run() }
        btn_loginB_close.setOnClickListener { onClickClose.run() }
    }

    private fun setupEmailLoginBtn() {
        view_loginB_emailLogin.setOnClickListener {
            view_loginB_emailLogin.isEnabled = false
            val dialog = AlertDialog.Builder(context)
                .setView(view)
                .setOnDismissListener {
                    val inputMethodManager =
                        context.getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
                    if (inputMethodManager.isActive) {
                        inputMethodManager.toggleSoftInput(InputMethodManager.HIDE_IMPLICIT_ONLY, 0)
                    }
                    (view.parent as ViewGroup).removeAllViews()
                    view_loginB_emailLogin.isEnabled = true
                    post {
                        requestFocus()
                        inputMethodManager.hideSoftInputFromWindow(windowToken, 0)
                    }
                }
                .show()

            formView.let {
                it.isRemember = isRemember
                it.email = email
                it.pwd = pwd
                it.onSubmit = Runnable {
                    dialog.dismiss()
                    onClickEmailLogin.run()
                }
                it.onClickPwdHelp = View.OnClickListener { onClickPwdHelp.run() }
            }
        }
    }
}