package com.kdanmobile.kdanloginregisterui

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.appcompat.app.AlertDialog
import com.kdanmobile.kdanloginregisterui.widget.EmailRegisterFormView
import kotlinx.android.synthetic.main.activity_register_b.view.*

class RegisterBView @JvmOverloads constructor(
        context: Context,
        attrs: AttributeSet? = null,
        defStyleAttr: Int = 0) : BaseRegisterView(context, attrs, defStyleAttr) {

    private val view = LayoutInflater.from(context).inflate(R.layout.dialog_email_register, null)
    private val formView = view.findViewById<EmailRegisterFormView>(R.id.formView_emailRegisterDialog)

    override val name: String
        get() = formView.name
    override val email: String
        get() = formView.email
    override val pwd: String
        get() = formView.pwd

    init {
        View.inflate(context, R.layout.activity_register_b, this)
        setupSwitchTextView(tv_registerB_switchToLogin)
        setupTosAndPpTextView(tv_registerB_tosAndPp)
        setupEmailRegisterBtn()
        view_registerB_fbRegister.setOnClickListener { onClickFbRegister.run() }
        view_registerB_googleRegister.setOnClickListener { onClickGoogleRegister.run() }
        btn_registerB_close.setOnClickListener { onClickClose.run() }
    }

    private fun setupEmailRegisterBtn() {
        view_registerB_emailRegister.setOnClickListener {
            view_registerB_emailRegister.isEnabled = false
            val dialog = AlertDialog.Builder(context)
                    .setView(view)
                    .setOnDismissListener {
                        (view.parent as ViewGroup).removeAllViews()
                        view_registerB_emailRegister.isEnabled = true
                    }
                    .show()
            formView.let {
                it.onSubmit = Runnable {
                    onClickEmailRegister.run()
                    dialog.dismiss()
                }
            }
        }
    }
}