package com.kdanmobile.kdanloginregisterui

import android.content.Context
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.DialogFragment
import androidx.fragment.app.FragmentManager
import kotlinx.android.synthetic.main.dialog_reset_pwd.*
import org.apache.commons.validator.routines.EmailValidator

class ResetPwdDialogFragment : DialogFragment() {
    private var listener: Listener? = null

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View {
        return inflater.inflate(R.layout.dialog_reset_pwd, container, false)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        btn_resetPwd_positive.setOnClickListener {
            val email = et_resetPwd_email.text.toString()
            if (email.isEmpty() || !EmailValidator.getInstance().isValid(email)) {
                val error = it.context.getString(R.string.kdanlrui_email_login_register_dialog_email_error)
                et_resetPwd_email.error = error
            } else {
                listener?.onClickSendResetPwdEmail(email)
                dismiss()
            }
        }
        btn_resetPwd_negative.setOnClickListener {
            dismiss()
        }
    }

    override fun onAttach(context: Context) {
        super.onAttach(context)
        if (context is Listener) {
            listener = context
        } else {
            if (BuildConfig.DEBUG) {
                val msg = "$context must implement ${ResetPwdDialogFragment.Listener::class.java.name}."
                throw RuntimeException(msg)
            }
        }
    }

    fun show(fragmentManager: FragmentManager) {
        show(fragmentManager, ResetPwdDialogFragment::class.java.simpleName)
    }

    interface Listener {
        fun onClickSendResetPwdEmail(email: String)
    }
}